package kata.wallet;

import java.math.BigDecimal;
import java.math.RoundingMode;

@SuppressWarnings("unused")
public enum Currency {
    AED(2, "United Arab Emirates dirham"),
    AFN(2, "Afghan afghani"),
    ALL(2, "Albanian lek"),
    AMD(2, "Armenian dram"),
    ANG(2, "Netherlands Antillean guilder"),
    AOA(2, "Angolan kwanza"),
    ARS(2, "Argentine peso"),
    AUD(2, "Australian dollar"),
    AWG(2, "Aruban florin"),
    AZN(2, "Azerbaijani manat"),
    BAM(2, "Bosnia and Herzegovina convertible mark"),
    BBD(2, "Barbados dollar"),
    BDT(2, "Bangladeshi taka"),
    BGN(2, "Bulgarian lev"),
    BHD(3, "Bahraini dinar"),
    BIF(0, "Burundian franc"),
    BMD(2, "Bermudian dollar"),
    BND(2, "Brunei dollar"),
    BOB(2, "Boliviano"),
    BOV(2, "Bolivian Mvdol"),
    BRL(2, "Brazilian real"),
    BSD(2, "Bahamian dollar"),
    BTN(2, "Bhutanese ngultrum"),
    BWP(2, "Botswana pula"),
    BYN(2, "Belarusian ruble"),
    BZD(2, "Belize dollar"),
    CAD(2, "Canadian dollar"),
    CDF(2, "Congolese franc"),
    CHE(2, "WIR Euro (complementary currency)"),
    CHF(2, "Swiss franc"),
    CHW(2, "WIR Franc (complementary currency)"),
    CLF(4, "Unidad de Fomento"),
    CLP(0, "Chilean peso"),
    CNY(2, "Chinese yuan"),
    COP(2, "Colombian peso"),
    COU(2, "Unidad de Valor Real (UVR)"),
    CRC(2, "Costa Rican colon"),
    CUC(2, "Cuban convertible peso"),
    CUP(2, "Cuban peso"),
    CVE(0, "Cape Verde escudo"),
    CZK(2, "Czech koruna"),
    DASH(8, "Dash"),
    DJF(0, "Djiboutian franc"),
    DKK(2, "Danish krone"),
    DOP(2, "Dominican peso"),
    DZD(2, "Algerian dinar"),
    EGP(2, "Egyptian pound"),
    ERN(2, "Eritrean nakfa"),
    ETB(2, "Ethiopian birr"),
    ETH(2, "Ether"),
    EUR(2, "Euro"),
    FJD(2, "Fiji dollar"),
    FKP(2, "Falkland Islands pound"),
    GBP(2, "Pound sterling"),
    GEL(2, "Georgian lari"),
    GHS(2, "Ghanaian cedi"),
    GIP(2, "Gibraltar pound"),
    GMD(2, "Gambian dalasi"),
    GNF(0, "Guinean franc"),
    GTQ(2, "Guatemalan quetzal"),
    GYD(2, "Guyanese dollar"),
    HKD(2, "Hong Kong dollar"),
    HNL(2, "Honduran lempira"),
    HRK(2, "Croatian kuna"),
    HTG(2, "Haitian gourde"),
    HUF(2, "Hungarian forint"),
    IDR(2, "Indonesian rupiah"),
    ILS(2, "Israeli new shekel"),
    INR(2, "Indian rupee"),
    IOT(0, "IOTA"),
    IQD(3, "Iraqi dinar"),
    IRR(2, "Iranian rial"),
    ISK(0, "Icelandic króna"),
    JMD(2, "Jamaican dollar"),
    JOD(3, "Jordanian dinar"),
    JPY(0, "Japanese yen"),
    KES(2, "Kenyan shilling"),
    KGS(2, "Kyrgyzstani som"),
    KHR(2, "Cambodian riel"),
    KMF(0, "Comoro franc"),
    KPW(2, "North Korean won"),
    KRW(2, "South Korean won"),
    KWD(3, "Kuwaiti dinar"),
    KYD(2, "Cayman Islands dollar"),
    KZT(2, "Kazakhstani tenge"),
    LAK(2, "Lao kip"),
    LBP(2, "Lebanese pound"),
    LKR(2, "Sri Lankan rupee"),
    LRD(2, "Liberian dollar"),
    LSL(2, "Lesotho loti"),
    LYD(3, "Libyan dinar"),
    MAD(2, "Moroccan dirham"),
    MDL(2, "Moldovan leu"),
    MGA(1, "Malagasy ariary"),
    MKD(2, "Macedonian denar"),
    MMK(2, "Myanmar kyat"),
    MNT(2, "Mongolian tögrög"),
    MOP(2, "Macanese pataca"),
    MRO(1, "Mauritanian ouguiya"),
    MUR(2, "Mauritian rupee"),
    MVR(2, "Maldivian rufiyaa"),
    MWK(2, "Malawian kwacha"),
    MXN(2, "Mexican peso"),
    MXV(2, "Mexican Unidad de Inversion (UDI)"),
    MYR(2, "Malaysian ringgit"),
    MZN(2, "Mozambican metical"),
    NAD(2, "Namibian dollar"),
    NGN(2, "Nigerian naira"),
    NIO(2, "Nicaraguan córdoba"),
    NOK(2, "Norwegian krone"),
    NPR(2, "Nepalese rupee"),
    NZD(2, "New Zealand dollar"),
    OMR(3, "Omani rial"),
    PAB(2, "Panamanian balboa"),
    PEN(2, "Peruvian Sol"),
    PGK(2, "Papua New Guinean kina"),
    PHP(2, "Philippine peso"),
    PKR(2, "Pakistani rupee"),
    PLN(2, "Polish złoty"),
    PYG(0, "Paraguayan guaraní"),
    QAR(2, "Qatari riyal"),
    RON(2, "Romanian leu"),
    RSD(2, "Serbian dinar"),
    RUB(2, "Russian ruble"),
    RWF(0, "Rwandan franc"),
    SAR(2, "Saudi riyal"),
    SBD(2, "Solomon Islands dollar"),
    SCR(2, "Seychelles rupee"),
    SDG(2, "Sudanese pound"),
    SEK(2, "Swedish krona/kronor"),
    SGD(2, "Singapore dollar"),
    SHP(2, "Saint Helena pound"),
    SLL(2, "Sierra Leonean leone"),
    SOS(2, "Somali shilling"),
    SRD(2, "Surinamese dollar"),
    SSP(2, "South Sudanese pound"),
    STD(2, "São Tomé and Príncipe dobra"),
    SVC(2, "Salvadoran colón"),
    SYP(2, "Syrian pound"),
    SZL(2, "Swazi lilangeni"),
    THB(2, "Thai baht"),
    TJS(2, "Tajikistani somoni"),
    TMT(2, "Turkmenistan manat"),
    TND(3, "Tunisian dinar"),
    TOP(2, "Tongan paʻanga"),
    TRY(2, "Turkish lira"),
    TTD(2, "Trinidad and Tobago dollar"),
    TWD(2, "New Taiwan dollar"),
    TZS(2, "Tanzanian shilling"),
    UAH(2, "Ukrainian hryvnia"),
    UGX(0, "Ugandan shilling"),
    USD(3, "United States dollar"),
    USN(2, "United States dollar (next day)"),
    UYI(0, "Uruguay Peso en Unidades Indexadas (URUIURUI)"),
    UYU(2, "Uruguayan peso"),
    UZS(2, "Uzbekistan som"),
    VEF(2, "Venezuelan bolívar"),
    VND(0, "Vietnamese đồng"),
    VUV(0, "Vanuatu vatu"),
    WST(2, "Samoan tala"),
    XAF(0, "CFA franc BEAC"),
    XAG(8, "Silver (one troy ounce)"),
    XAU(8, "Gold (one troy ounce)"),
    XBC(8, "Bitcoin Cash"),
    XBT(8, "Bitcoin Cash"),
    XCD(2, "East Caribbean dollar"),
    XLM(8, "Stellar Lumen"),
    XMR(8, "Monero"),
    XOF(0, "CFA franc BCEAO"),
    XPD(8, "Palladium (one troy ounce)"),
    XPF(0, "CFP franc (franc Pacifique)"),
    XPT(8, "Platinum (one troy ounce)"),
    XRP(8, "Ripple"),
    XSU(8, "SUCRE"),
    XZC(8, "Zcoin"),
    YER(2, "Yemeni rial"),
    ZAR(2, "South African rand"),
    ZEC(8, "Zcash"),
    ZMW(2, "Zambian kwacha"),
    ZWL(2, "Zimbabwean dollar A/10");

    public static Currency find(final String name) {
        for (final Currency value : Currency.values()) {
            if (value.name().equalsIgnoreCase(name)) {
                return value;
            }
        }
        throw new IllegalArgumentException("Currency not found: " + name);
    }

    private final int precision;
    private String fullname;

    Currency(int precision, String fullname) {
        this.precision = precision;
        this.fullname = fullname;
    }

    public String isoCode() {
        return this.toString();
    }

    BigDecimal round(BigDecimal value) {
        return value.setScale(precision, RoundingMode.HALF_UP);
    }

    String render(BigDecimal value) {
        return round(value).toPlainString();
    }
}
